package com.perforce.hwsclient.models;

import java.util.Objects;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import com.google.gson.annotations.SerializedName;




@ApiModel(description = "")
public class ChangelistAction   {
  
  @SerializedName("depotFile")
  private String depotFile = null;
  
  @SerializedName("fromDepotFile")
  private String fromDepotFile = null;
  
  @SerializedName("actionType")
  private String actionType = null;
  
  @SerializedName("content")
  private String content = null;
  
  @SerializedName("requireVersion")
  private Integer requireVersion = null;
  

  
  /**
   * The target file path to edit.
   **/
  @ApiModelProperty(value = "The target file path to edit.")
  public String getDepotFile() {
    return depotFile;
  }
  public void setDepotFile(String depotFile) {
    this.depotFile = depotFile;
  }

  
  /**
   * For \"branch\" or \"move\" actions, this indicates the source file location.
   **/
  @ApiModelProperty(value = "For \"branch\" or \"move\" actions, this indicates the source file location.")
  public String getFromDepotFile() {
    return fromDepotFile;
  }
  public void setFromDepotFile(String fromDepotFile) {
    this.fromDepotFile = fromDepotFile;
  }

  
  /**
   * One of \"upload\", \"branch\", \"move\", or \"delete\"
   **/
  @ApiModelProperty(value = "One of \"upload\", \"branch\", \"move\", or \"delete\"")
  public String getActionType() {
    return actionType;
  }
  public void setActionType(String actionType) {
    this.actionType = actionType;
  }

  
  /**
   * Base64-encoded content
   **/
  @ApiModelProperty(value = "Base64-encoded content")
  public String getContent() {
    return content;
  }
  public void setContent(String content) {
    this.content = content;
  }

  
  /**
   * If set, we will only operate if this is the current version of the file.
   **/
  @ApiModelProperty(value = "If set, we will only operate if this is the current version of the file.")
  public Integer getRequireVersion() {
    return requireVersion;
  }
  public void setRequireVersion(Integer requireVersion) {
    this.requireVersion = requireVersion;
  }

  

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ChangelistAction changelistAction = (ChangelistAction) o;
    return Objects.equals(this.depotFile, changelistAction.depotFile) &&
        Objects.equals(this.fromDepotFile, changelistAction.fromDepotFile) &&
        Objects.equals(this.actionType, changelistAction.actionType) &&
        Objects.equals(this.content, changelistAction.content) &&
        Objects.equals(this.requireVersion, changelistAction.requireVersion);
  }

  @Override
  public int hashCode() {
    return Objects.hash(depotFile, fromDepotFile, actionType, content, requireVersion);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ChangelistAction {\n");
    
    sb.append("    depotFile: ").append(toIndentedString(depotFile)).append("\n");
    sb.append("    fromDepotFile: ").append(toIndentedString(fromDepotFile)).append("\n");
    sb.append("    actionType: ").append(toIndentedString(actionType)).append("\n");
    sb.append("    content: ").append(toIndentedString(content)).append("\n");
    sb.append("    requireVersion: ").append(toIndentedString(requireVersion)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}
