package com.perforce.hwsclient.models;

import java.util.Objects;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import com.google.gson.annotations.SerializedName;




/**
 * Either of our login methods return a ticket, which is then used as a password in a basic authentication scheme.\n\nWhen this is returned from the explicit p4d login, this is a host unlocked ticket, acceptable for using with a local client.
 **/
@ApiModel(description = "Either of our login methods return a ticket, which is then used as a password in a basic authentication scheme.\n\nWhen this is returned from the explicit p4d login, this is a host unlocked ticket, acceptable for using with a local client.")
public class LoginResponse   {
  
  @SerializedName("ticket")
  private String ticket = null;
  

  
  /**
   **/
  @ApiModelProperty(value = "")
  public String getTicket() {
    return ticket;
  }
  public void setTicket(String ticket) {
    this.ticket = ticket;
  }

  

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    LoginResponse loginResponse = (LoginResponse) o;
    return Objects.equals(this.ticket, loginResponse.ticket);
  }

  @Override
  public int hashCode() {
    return Objects.hash(ticket);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class LoginResponse {\n");
    
    sb.append("    ticket: ").append(toIndentedString(ticket)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}
